---
title: RTCConfiguration.iceServers
slug: Web/API/RTCConfiguration/iceServers
tags:
  - API
  - Configuration
  - ICE
  - JSEP
  - Negotiation
  - Property
  - RTCConfiguration
  - Reference
  - SDP
  - STUN
  - TURN
  - WebRTC
  - WebRTC API
  - WebRTC Device API
  - iceServers
---
<div id="show_cache">
<p>{{DefaultAPISidebar("WebRTC API")}}</p>

<p>The {{domxref("RTCConfiguration")}} dictionary's <code><strong>iceServers</strong></code> property is an array of {{domxref("RTCIceServer")}} objects, each of which describes a single {{Glossary("STUN")}} or {{Glossary("TURN")}} server to use for negotiation purposes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let rtcConfiguration = {
  iceServers: [ <em>iceServer1...</em> ]
};

let rtcConfiguration.iceServers = [ <em>iceServer1...</em> ];
</pre>

<h3 id="Value">Value</h3>

<p>An array of zero or more {{domxref("RTCIceServer")}} objects, each of which describes one <a href="/en-US/docs/Web/API/WebRTC_API/Protocols">STUN or TURN server</a> for the ICE agent to use <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#Establishing_the_connection">during the connection's negotiation</a>. Each object must at least have an {{domxref("RTCIceServer.urls", "urls")}} property, which is an array of one or more strings, each providing one server's URL.</p>

<p>If the array is empty, or if the <code>iceServers</code> option isn't specified, the ICE agent will negotiate without the use of any servers, which will limit the connection to local peers.</p>

<h2 id="Description">Description</h2>

<p>How the list of servers you provide is used is up to the implementation of the {{Glossary("user agent")}}. While it can be useful to provide a second server as a fallback in case the first is offline, listing too many servers can delay the user's connection being established, depending on the network's performance and how many servers get used for negotiation before a connection is established.</p>

<p>If the list of servers is changed while a connection is already active by calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.setConfiguration", "setConfiguration()")}}, no immediate effect occurs. However, the new list of servers is used for any future renegotiation, such as while handling an <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#ICE_restart">ICE restart</a>.</p>

<h2 id="Examples">Examples</h2>

<p>The configuration below opens a new peer connection, specifying two servers for the ICE agent to use for negotiation. The first one, <code>stun:stun.services.mozilla.com</code>, requires authentication, so the username and password are provided. The second server has two URLs: <code>stun:stun.example.com</code> and <code>stun:stun-1.example.com</code>.</p>

<pre class="brush: js notranslate">var configuration = { iceServers: [{
                          urls: "stun:stun.services.mozilla.com",
                          username: "louis@mozilla.com",
                          credential: "webrtcdemo"
                      }, {
                          urls: ["stun:stun.example.com", "stun:stun-1.example.com"]
                      }]
};

var pc = new RTCPeerConnection(configuration);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0','#dom-rtcconfiguration-iceservers','RTCConfiguration.iceServers')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCConfiguration.iceServers")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#Establishing_the_connection">Lifetime of a WebRTC connection</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Perfect_negotiation">Establishing a connection: The WebRTC perfect negotiation pattern</a></li>
</ul>
</div>
</div>
